# О bem-xjst

## Что такое bem-xjst?
bem-xjst — шаблонизатор для тех, кто ведет веб-разработку в рамках БЭМ-методологии. Начиная с версии 5.0.0 шаблонизатор содержит два движка:

1. BEMHTML — для преобразования BEMJSON в HTML.
1. BEMTREE — для преобразования BEMJSON с данными в BEMJSON с БЭМ-деревом для последующего преобразования с помощью BEMHTML.

В основе шаблонизатора лежат декларативные принципы из [XSLT](https://www.w3.org/TR/xslt) (eXtensible Stylesheet Language Transformations). По аналогии было придумано название XJST — eXtensible JavaScript Transformations.

Для работы с шаблонизатором вам стоит изучить:

1. [Формат входных данных — BEMJSON](4-data.md)
1. [Как писать шаблоны](5-templates-syntax.md)
1. [Процессы выбора и применения шаблонов](7-runtime.md)

## Отличительные черты
1. Шаблоны расширяемы: их можно переопределить или доопределить.
1. Для написания шаблонов используется [сопоставление с образцом](7-runtime.md#matching) (pattern matching) по значениям и структуре входных данных.
1. Обходит входные данные по умолчанию.
1. Есть встроенное поведение рендеринга по умолчанию, даже если пользователь не добавил шаблонов.
1. Написан на JavaScript — можно проводить проверки качества и корректности кода, пользоваться всей инфраструктурой JS.
1. Не требует компиляции шаблонов.
1. Предоставляет API для добавления шаблонов в рантайме.
1. Работает на сервере и клиенте.


***

Читать далее: [быстрый старт](2-quick-start.md)
